Subject: bug#28273: closed (Re: [bug#28273] [PATCH] gnu: Fix current-guix.)

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 31 Aug 2017 21:05:02 +0000

Your bug report

#28273: [PATCH] gnu: Fix current-guix.

which was filed against the guix-patches package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
28273: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=28273
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: [bug#28273] [PATCH] gnu: Fix current-guix.
From: Christopher Baines <[email-masked]>
To: [email-masked] (Ludovic Courtès)
Cc: [email-masked]
Date: Thu, 31 Aug 2017 22:04:21 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

On Thu, 31 Aug 2017 15:18:37 +0200
[email-masked] (Ludovic Courtès) wrote:

> Christopher Baines <[email-masked]> skribis:
> 
> > Without this change, I get errors like:
> >   ERROR: In procedure string-drop:
> >   ERROR: Value out of range 0 to 35: 51
> >
> > * gnu/packages/package-management.scm (current-guix): Pass exactly
> > the same path to git-predicate and local-file, to ensure that the
> > select? function is compatible.  
> 
> Good catch, LGTM.

Great, I've merged this now.

> I think that fundamentally, we should arrange for ‘git-predicate’ to
> not do any string prefix comparison.  That’s bound to fail.  If we
> could somehow restrict it to comparing inode numbers, that’d be
> perfect.

Hmm, yeah, that might work well... I think the structure would simplify
to:
 - taking the list of files, creating a list of directories
   (rather than a tree)
 - combining these lists
 - finding each inode for every file and directory

The predicate could then check if the provided inode is known, without
switching on the type as it does at the moment.

I'll put it on my list of things to look at :)

Subject: [PATCH] gnu: Fix current-guix.
From: Christopher Baines <[email-masked]>
To: [email-masked]
Date: Tue, 29 Aug 2017 07:49:30 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Without this change, I get errors like:
  ERROR: In procedure string-drop:
  ERROR: Value out of range 0 to 35: 51

* gnu/packages/package-management.scm (current-guix): Pass exactly the same
  path to git-predicate and local-file, to ensure that the select? function is
  compatible.
---
 gnu/packages/package-management.scm | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

diff --git a/gnu/packages/package-management.scm b/gnu/packages/package-management.scm
index 67a956dea..a6c97e618 100644
--- a/gnu/packages/package-management.scm
+++ b/gnu/packages/package-management.scm
@@ -312,10 +312,11 @@ generated file."
      #t)))
 
 (define-public current-guix
-  (let ((select? (delay (or (git-predicate
-                             (string-append (current-source-directory)
-                                            "/../.."))
-                            source-file?))))
+  (let* ((repository-root (canonicalize-path
+                           (string-append (current-source-directory)
+                                          "/../..")))
+         (select? (delay (or (git-predicate repository-root)
+                             source-file?))))
     (lambda ()
       "Return a package representing Guix built from the current source tree.
 This works by adding the current source tree to the store (after filtering it
@@ -323,7 +324,7 @@ out) and returning a package that uses that as its 'source'."
       (package
         (inherit guix)
         (version (string-append (package-version guix) "+"))
-        (source (local-file "../.." "guix-current"
+        (source (local-file repository-root "guix-current"
                             #:recursive? #t
                             #:select? (force select?)))))))
 
-- 
2.14.1